#ifndef PROJDB_H_
#define PROJDB_H_

#include "sequence.h"
#include <fstream>
#include <iostream>
#include <vector>

using namespace std;





//filereader
int binaryReader(vector<int>* sdb,char* filename,int& seqCount,int& longest){
	ifstream file(filename,ios::binary);
	int temp ;
	int max = -1;
	seqCount = 0;
	longest = 0;
	int countLongest = 0;
	while(file.read((char*)&temp,4)){
		if(temp>-1){
			if(temp > max) max = temp;
			sdb->push_back(temp);
			++countLongest;
		}
		else{
			sdb->push_back(temp);
			if(temp==-2) {
				seqCount++;
				if(countLongest>longest) longest = countLongest;
				countLongest = 0;
			}
		}
	}
	file.close();
	return max;
}

class pdb{
public:
	static time_t begintime,endtime,sumtime;
	vector<int>* seqBeginPos;

	pdb(){
		seqBeginPos = new vector<int>();
	}

	~pdb(){
		delete seqBeginPos;
	}

	int buildL1LFI(vector<int>* sdb,vector<int>* counter,vector<int>* lastVisit,int min_sup,vector<int>* LFI){
		seqBeginPos->push_back(0);
		int loopEnd = sdb->size()-2;
		for(int i=0;i<loopEnd;++i){
			if((*sdb)[i] == -2){
				seqBeginPos->push_back(i+1);
			}
			else if( (*sdb)[i] != -1 ){
				if( (*lastVisit)[ (*sdb)[i] ] != seqBeginPos->back() ){
					++ (*counter)[ (*sdb)[i] ];
					(*lastVisit)[ (*sdb)[i] ] = seqBeginPos->back();
				}
			}
		}
		int LFIAmount = 0;
		//for(int i=0;i<counter->size();++i){//wjy
		for(i=0;i<counter->size();++i){
			if( (*counter)[i] >= min_sup){
				(*LFI)[i] = LFIAmount;
				++LFIAmount;
			}
		}
		return LFIAmount;
	}

	int getSLFI(vector<int>* sdb,vector<int>* counter,vector<int>* lastVisit,int min_sup,vector<int>* LFI,int patternSup,int* fei){
		lastVisit->assign(lastVisit->size(),-1);
		counter->assign(counter->size(),0);
		LFI->assign(LFI->size(),-1);
		int j;
		*fei = 0;
		begintime = clock();
		for(int i=0;i<seqBeginPos->size();++i){
			j=(*seqBeginPos)[i];
			if(j>0 && (*sdb)[j-1]!=-1){
				while( (*sdb)[j] != -1) ++j;
			}
			while( (*sdb)[j] != -2){
				if( (*sdb)[j] != -1){
					if( (*lastVisit)[ (*sdb)[j] ] != (*seqBeginPos)[i] ){
						(*lastVisit)[ (*sdb)[j] ] = (*seqBeginPos)[i];
						++ (*counter)[ (*sdb)[j] ];
					}
				}
				++j;
			}
		}
		endtime=clock();
		sumtime+=endtime-begintime;
		int LFIAmount = 0;
		//for(int i=0;i<counter->size();++i){//wjy
		for(i=0;i<counter->size();++i){
			if( (*counter)[i] >= min_sup){
				(*LFI)[i] = LFIAmount;
				++LFIAmount;
				if( (*counter)[i] == patternSup ){
					++(*fei);
				}
			}
		}
		return LFIAmount;
	}

	int getILFI(vector<int>* sdb,vector<int>* counter,vector<int>* lastVisit,int min_sup,vector<int>* LFI,vector<int>* pattern,int patternSup,int* fei){
		lastVisit->assign(lastVisit->size(),-1);
		counter->assign(counter->size(),0);
		LFI->assign(LFI->size(),-1);

		int j;
		*fei = 0;
		int matched = 0;
		int patternBeginPos= pattern->size()-2;
		while(patternBeginPos>0 && (*pattern)[patternBeginPos-1] != -1 ) --patternBeginPos;
		for(int i=0;i<seqBeginPos->size();++i){
			j=(*seqBeginPos)[i];
			if(j>0 && (*sdb)[j-1]!=-1){
				while( (*sdb)[j] != -1){
					if( (*lastVisit)[ (*sdb)[j] ] != (*seqBeginPos)[i] ){
						(*lastVisit)[ (*sdb)[j] ] = (*seqBeginPos)[i];
						++ (*counter)[ (*sdb)[j] ];
					}
					++j;
				}
			}
			++j;
			while( (*sdb)[j] != -2){
				int patternIter = patternBeginPos;
				while((*sdb)[j] != -1 && (*pattern)[patternIter] != -1){
					if( (*sdb)[j] == (*pattern)[patternIter]){
						++patternIter;
						if((*pattern)[patternIter] == -1){
							matched = 1;
						}
					}
					++j;
				}
				if(matched == 0){
					while( (*sdb)[j] != -1 ) ++j;
				}
				else{
					while( (*sdb)[j] != -1 ) {
						if( (*lastVisit)[ (*sdb)[j] ] != (*seqBeginPos)[i] ){
							(*lastVisit)[ (*sdb)[j] ] = (*seqBeginPos)[i];
							++ (*counter)[ (*sdb)[j] ];
						}						
						++j;
					}
					matched = 0;
				}				
				++j;
			}
		}
		int LFIAmount = 0;
		//for(int i=0;i<counter->size();++i){//wjy
		for(i=0;i<counter->size();++i){
			if( (*counter)[i] >= min_sup){
				(*LFI)[i] = LFIAmount;
				++LFIAmount;
				if( (*counter)[i] == patternSup ){
					++(*fei);
				}
			}
		}
		return LFIAmount;
	}
};

#endif