package com.ser.assist
import com.mongodb.*
//read frequent.dat
//use simple algorithm and collate method traces



//def dbName = "jagg"
//def dbName = "Shtutxml"
//def frequentDatFilePath = "/Users/gdevanla/Documents/bide-files/Shtutxml/0.002/frequent.dat"

//def dbName = "scribe"
//def frequentDatFilePath = "/Users/gdevanla/Documents/bide-files/scribe/0.01/frequent.dat"

def dbName = "nanoxml"
def frequentDatFilePath = "/Users/gdevanla/Documents/bide-files/nanoxml/0.02/frequent.dat"


MongoClient mongoClient = new MongoClient();
DB db = mongoClient.getDB(dbName);

def coll = db.getCollection("method_index");

//def f = new File("/Users/gdevanla/Documents/bide-files/frequent.dat")
def f = new File(frequentDatFilePath)

//convert index to method names
List<String> lines = f.readLines()
def frequentMethods =  []
for (String l: lines) {
    List<String> items = l.split(":")[0].split(" ")

    List<String> method_names = items.inject([]) { acc, it ->
        acc + coll.find(new BasicDBObject("index", Integer.parseInt(it))).collect([]) {it}
    }

    frequentMethods.add(method_names)

}

/*
def firstInSequenceMethods = frequentMethods.collect([]) { it
    it.get(0)
}
//method we want to generate integration tests for.
println firstInSequenceMethods.unique()
*/

//getting methods all same levels

def getMethodSequences(db) {
    //MongoClient mongoClient = new MongoClient();
    //DB db = mongoClient.getDB(dbName);
    def coll = db.getCollection("method_sequence");
    return coll.find()
}

def getMethodTracesFromCounters(db, List counters) {
    BasicDBList orList = new BasicDBList()
    counters.each() {
        orList.add(new BasicDBObject("counter", it))
    }
    DBObject query = new BasicDBObject("\$or", orList)

    //MongoClient mongoClient = new MongoClient();
    //DB db = mongoClient.getDB(dbName);
    def coll = db.getCollection("method_trace");
    def method_traces = coll.find(query);

    method_traces.collect([]) { it }

}


def method_sequences = getMethodSequences(db)
def method_trace_sequences = method_sequences.inject([]) { acc, seq ->
    List counters = seq.get("counters")
    List method_traces =  getMethodTracesFromCounters(db, counters)
    //println "${counters.size()}, ${method_traces.size()}"
    acc <<  method_traces
}


def levels_in_sequences = []
method_trace_sequences.each() { method_trace_seq ->
    def level = [:].withDefault {[]}
    method_trace_seq.each() { mt ->
        level[mt.get("level")] << mt
    }
    levels_in_sequences = levels_in_sequences + level.values()
}

//print levels_in_sequences.get(0)

def getValidSequences(freq_seq, mt_at_level, acc )
{
    if (freq_seq.size() == 0 || mt_at_level.size() == 0)
        return acc

    //println mt_at_level[0]
    String methodKey = mt_at_level[0].get("class-name") + ":" + mt_at_level[0].get("method-name")
    if ( freq_seq[0].get("method-key") == methodKey ){
        acc << mt_at_level[0]
        getValidSequences(freq_seq.drop(1), mt_at_level.drop(1), acc)
    }
    else
    {
        getValidSequences(freq_seq, mt_at_level.drop(1), acc)
    }
}


def valid_sequences = [:].withDefault {[]}
for(def freq_seq:frequentMethods){
    for (def mt_at_level:levels_in_sequences){
        def valid_sequence = []
        getValidSequences(freq_seq, mt_at_level, valid_sequence)
        if ( valid_sequence.size() > valid_sequences[freq_seq].size() )
            valid_sequences[freq_seq] = valid_sequence
    }
}

println valid_sequences.keySet()[0]
key =   valid_sequences.keySet()[0]
println valid_sequences[key]
//println valid_sequences.values();

def mut_list_coll = db.getCollection("mut_lists");
mut_list_coll.drop()
//we will get one instance of method_trace sequence for each freq sequence
valid_sequences.each() { key, value ->
      //create entries in mongo for this valid sequences
      //tests will be created for these sequences

    BasicDBObject o = new BasicDBObject().append("muts", value)

    mut_list_coll.insert(o)

}

def key = new BasicDBObject("_id", new BasicDBObject("muts", "\$muts"))
def mm = mut_list_coll.aggregate(new BasicDBObject("\$group", key))
def x = mm.getCommandResult()
println x.size()

def result = x.get("result")
result.each() {
   println it.get("_id").get("muts").size()
   //println
}
println "Total unique method traces to generate code for ${result.size()}"


















