package com.ser.assist
import com.mongodb.*
import com.ser.assist.statecarver.xstreamcarver.XStreamStateCarver
import com.ser.assist.testgenerator.MethodTrace
import org.json.simple.JSONArray
/**
 * Created by gdevanla on 2/18/14.
 */
class StateStore {

    static String STATE_COLL = "state_trace"
    static String MT_COLL = "method_trace"
    static MongoClient mongoClient = new MongoClient()


    public static void insertMethodTrace(String dbName, doc){
        //def db = mongoClient.getDB(dbName);
        DB db = mongoClient.getDB(dbName);
        DBCollection mt_coll = db.getCollection(MT_COLL)
        mt_coll.insert(doc);
    }


    public static void main(String[] args){
        StateStore.insertMethodTrace("testdb", new MethodTrace(1, "test-class", "test-method", 1, -100));
    }

    static void insertState(String dbName, BasicDBObject dbObject) {
        DB db = mongoClient.getDB(dbName);
        DBCollection st_coll = db.getCollection(STATE_COLL)
        st_coll.insert(dbObject);
    }

    static List getAllMethodTraces(dbName) {
        DB db = mongoClient.getDB(dbName);
        DBCollection mt_coll = db.getCollection(MT_COLL)
        List mts = mt_coll.find().collect([]) { it ->
            [new MethodTrace( it["counter"],
                    it["class-name"],
                    it["method-name"], it["level"], it["object-id"])]
        }

        return mts
    }

    static BasicDBObject getMethodTraceByCounter(dbName, counter) {

        //Assumes the counter requested always exists.
        DB db = mongoClient.getDB(dbName);
        DBCollection mt_coll = db.getCollection(MT_COLL);
        def cursor = mt_coll.find(new BasicDBObject("counter", counter));
        return cursor.next();

    }



    static List getCollatedMethodTraces(dbName, listName){
        DB db = mongoClient.getDB(dbName);
        DBCollection mut_list_coll = db.getCollection(listName);

        def key = new BasicDBObject("_id", new BasicDBObject("muts", "\$muts"))
        def mm = mut_list_coll.aggregate(new BasicDBObject("\$group", key))
        def x = mm.getCommandResult()
        println x.size()

        def result = x.get("result")
        def mut_lists = []
        result.each() {
            def muts = it.get("_id").get("muts")
            def mut_list = muts.collect([]) { mut ->
                new MethodTrace( mut["counter"],
                        mut["class-name"],
                        mut["method-name"], mut["level"], mut["object-id"])
            }
            mut_lists.add(mut_list)
        }

        return mut_lists
    }



    static String getState(dbName, ctr, var) {

        DB db = mongoClient.getDB(dbName);
        def coll = db.getCollection(STATE_COLL)
        def arr = new JSONArray()
        arr.addAll([ new BasicDBObject("ctr", ctr),
                new BasicDBObject("var", var)])

        DBObject dbObject = coll.findOne(new BasicDBObject("\$and", arr))
        return dbObject["data"];

    }

    static List getStaticStates(dbName, ctr) {

        DB db = mongoClient.getDB(dbName);
        def coll = db.getCollection(STATE_COLL)
        def arr = new JSONArray()
        arr.addAll([ new BasicDBObject("ctr", ctr),
                new BasicDBObject("var", XStreamStateCarver.STATIC_VAR)])

        DBCursor cursor = coll.find(new BasicDBObject("\$and", arr))
        return cursor.collect() {
            [it["prnt-cls"], it["var-name"], it["data"]]
        }

    }






}
