package com.ser.assist.statecarver.core;

import com.mongodb.BasicDBObject;
import com.ser.assist.StateStore;

public class MethodTracer {

    //create the trace folders
    /*{
    try {
        //dirty way to create a new file
        new FileWriter(
                StateCarverConfiguration.v().getMethodTraceFileName(), false);
        FileUtils.cleanDirectory(new File(StateCarverConfiguration.v().getTraceDestination()));
    }
    catch (IOException e) {
        System.out.println("Unable to create directory to write trace files\n");
        e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
    }
    }*/

    private static final MethodTracer methodTracer = new MethodTracer();

    private MethodTracer() {

    }

  /*  private PrintWriter pw;
    private MethodTracer(){

        try
        {
        pw = new PrintWriter(new BufferedWriter(
                new FileWriter(
                        StateCarverConfiguration.v().getMethodTraceFileName(), true)));
        pw.write("["); //hack: open the json list
        //pw.flush();
        }
        catch (IOException ex){
            System.out.println("Unable to create file to trace method calls\n");
            ex.printStackTrace();
        }

        //Register shutdown hook to close this file handle.
        Runtime.getRuntime().addShutdownHook(new Thread(new Runnable() {
            @Override
            public void run() {
                System.out.println("Closing Method Tracer handle from inside shutdown hook\n");
                if (pw == null) {
                    //TODO: Add logger here.
                    System.out.println("pw is null");
                }
                else {
                    pw.write("]"); //close the json list.
                    pw.close();
                }
            }
        }));
    }
*/
    public static void writeMethodTrace(String appName, String methodName, String className, long methodCounter, int objectId){
        //int level = (new Throwable()).getStackTrace().length;

        StackTraceElement[] elements = (new Throwable()).getStackTrace();
        int testLevel = -1;
        String testClass = "";
        String testMethod = "";
        String format = "ClassName=%s, MethodName=%s, FileName=%s , Level=%s, %b, %b, %b";

       /* for ( int i=0; i < elements.length;i++){
            System.out.println(i + ":" + elements[i]);
        }*/


        for ( int i= 0 ; i < elements.length; i++){
            StackTraceElement e = elements[i];
           /* System.out.println(String.format(format, e.getClassName(), e.getMethodName(), e.getFileName() , i,
                    e.getClassName().startsWith("net.n3"), e.getClassName().endsWith("Test"), e.getMethodName().startsWith("test")) );*/

            //short cut to avoid instrumenting name of application. The assert
            //will remind me to update this code when using with other subject apps
            //System.out.println("Before condition check. " + testLevel);
            if ( (e.getClassName().startsWith("net.n3")) && //|| e.getClassName().startsWith("org.scribe") ||
                   // e.getClassName().startsWith("com.google.shtutxml")) &&
                    //e.getClassName().startsWith("org.apache.commons.graph") &&
                    e.getClassName().endsWith("Test") &&
                    e.getMethodName().startsWith("test")
                     )
            {
                //assert(testLevel == -1);
                testLevel = i;
                testClass = e.getClassName();
                testMethod = e.getMethodName();
                break;

            }
        }

        String template = "{\"counter\": %d , \"class-name\": \"%s\", \"method-name\": \"%s\", \"level\": %d },";

        //int level = 10;
       // String s = String.format(template, methodCounter, className, methodName, level );
        //System.out.println("In writeMethodTrace.." + s);

        StateStore.insertMethodTrace(appName, new
                BasicDBObject("counter", methodCounter).
                append("level", elements.length).
                append("class-name", className).
                append("method-name",methodName).
                append("object-id", objectId).
                append("test-class", testClass).
                append("test-method", testMethod).
                append("test-level", testLevel)); //elements.length-testLevel));


        //methodTracer.pw.write(s);
        //methodTracer.pw.flush();
    }

}
