package com.ser.assist.statecarver.xstreamcarver;

import com.mongodb.BasicDBObject;
import com.ser.assist.StateStore;
import com.ser.assist.statecarver.core.StateCarverConfiguration;
import com.thoughtworks.xstream.XStream;
import com.thoughtworks.xstream.converters.reflection.Sun14ReflectionProvider;
import com.thoughtworks.xstream.io.xml.DomDriver;
import com.thoughtworks.xstream.io.xml.StaxDriver;
import org.apache.commons.io.FilenameUtils;

import java.io.*;
import java.util.ArrayList;

public class XStreamStateCarver {

    public static int STATIC_VAR = 100;
    public static int THIS_VAR = 200;
    public static int RET_VAR = 300;

    private XStream xstream;
  //  private String fileName;

   private static XStreamStateCarver instance = new XStreamStateCarver();

    public XStreamStateCarver(){
       // this.fileName = MethodTracer.getStateFileForMethod();
        xstream = new XStream(new Sun14ReflectionProvider(),
                new DomDriver());

        //xstream.setMode();

        //TODO: Do I need to set a Marshalling Strategy?
       /* xstream.registerConverter(new StaticAttributeConverter(
                xstream.getMapper(),
                new StaticReflectionProvider()),
                XStream.PRIORITY_LOW);
                */
    }

    private void save(Object o, BasicDBObject dbObject, String appName){
        try
        {
            StringWriter s = new StringWriter();
            ObjectOutputStream out = xstream.createObjectOutputStream(s);
            out.writeObject(o);
            out.flush();
            out.close();
           // System.out.println("Just before writing with close\n " + s.toString());
            StateStore.insertState(appName, dbObject.append("data", s.toString()));

        }
        catch (Exception ex)
        {  //I need a better logger here
            System.err.println("Error while saving state " + o.toString() + o.getClass() + ex);
            System.err.println("Error in write Method Trace");
            System.exit(-1);
        }

       /* try{
            String filePath = getFilePath(fileName);
            System.out.println("Writing to file now.. =" + filePath);
            ObjectOutputStream out = xstream.createObjectOutputStream(new FileWriter(filePath, false));
            out.writeObject(o);

            out.close();
        }
        catch(IOException e){
            //I need a better logger here
            System.err.println("Error while saving state " + o.toString() + o.getClass() + e);
            System.err.println("Error in write Method Trace");
            System.exit(-1);
        }*/
    }

    private Object load(StringReader stringReader){
        try{
            ObjectInputStream in = xstream.createObjectInputStream(stringReader);
            Object o = in.readObject();
            return o;
        }
        catch(IOException e){
            System.out.println("Error while loading state from " +  stringReader.toString());
            e.printStackTrace();
        } catch (ClassNotFoundException e) {
            System.out.println("Error while loading state from " + stringReader.toString());
            e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
        }

        return null;
    }

    // Helper methods
    public static String getParamStateFileName(long methodCounter, String paramNumberOrThis, String type){
        return "state" + ":" + methodCounter + ":" + paramNumberOrThis + ".xml";
    }

    public static String getParamStateFileName(long methodCounter, String paramNumberOrThis){
        return "state" + ":" + methodCounter + ":" + paramNumberOrThis + ".xml";
    }

    public static String getStateFileName(long methodCounter)
    {
        return getParamStateFileName(methodCounter, "this");
    }

    public static String getParamFileName(long methodCounter, int index)
    {
        return getParamStateFileName(methodCounter, Integer.toString(index));
    }

    public static String getReturnFileName(long methodCounter)
    {
        return getParamStateFileName(methodCounter, "return");
    }

    public static void saveState(Object o, long methodCounter, int paramNumberOrThisOrRet, String type, String appName){
        //System.out.println("Saving state for methodCounter " + methodCounter + "type=" + type);
        //String fileName = getParamStateFileName(methodCounter, paramNumberOrThisOrRet, type);
        //saveStateToFile(o, fileName);
        instance.save(o,
                new BasicDBObject("ctr", methodCounter).
                append("var", paramNumberOrThisOrRet).
                append("type", type), appName);

    }

    public static void saveStateToFile(Object o, String fileName){
          //instance.save(o, fileName);
    }

    public static String getStaticStateFileName(long methodCounter, String enclosingClass,
                                           String type, String variableName){
        return "static" + ":" + methodCounter + ":" + enclosingClass +
                ":" + type + ":" + variableName + ".xml";
    }

    public static void saveStaticState(Object o, long methodCounter, String enclosingClass, String variableName,
                                       String type, String appName){
        //String fileName = getStaticStateFileName(methodCounter, enclosingClass, type, variableName);
        //instance.save(o, fileName);
        String fileName = getParamStateFileName(methodCounter, enclosingClass, type);
        //saveStateToFile(o, fileName);
        instance.save(o,
                new BasicDBObject("ctr", methodCounter).
                        append("var", STATIC_VAR).
                        append("type", type).
                        append("prnt-cls", enclosingClass).
                        append("var-name", variableName),
                appName);

    }

    public static Object loadState(String fileName) {
       return null;
        //return instance.load(getFilePath(fileName));
    }

    public static Object loadState(long methodCounter, int var, String appName) {
        String s = StateStore.getState(appName, methodCounter, var);
        StringReader stringReader = new StringReader(s);
        return instance.load(stringReader);

    }

    public static Object loadState(StringReader stringReader){
        return instance.load(stringReader);
    }



    private static String getFilePath(String fileName){
        //TODO: use proper path concatenation style
        return FilenameUtils.concat(StateCarverConfiguration.v().getTraceDestination(),
                fileName);
    }

   /* *//*Return contained class, type and field name for static data*//*
    public static String[] getFieldAttributes(String fileName){
        if (fileName.startsWith("static")){
                String[] parts = fileName.split(":");
                return new String[]{parts[2], parts[3], parts[4].split(".")[0]};
        }
        else{
                //not implemented yet
                return new String[]{};
        }

    }

    public static void loadStaticClasses() {
        //http://groovy.codehaus.org/JN3535-Reflection
        String fileName = "static:9:com.ser.instrument.artifacts.SingletonClass:com.ser.instrument.artifacts.SingletonClass:s.xml";
        String[] attr = getFieldAttributes(fileName)
        Object obj = com.ser.assist.statecarver.xstreamcarver.XStreamStateCarver.loadState(fileName);
        try {
            Class.forName(attr[0]).getField(attr[2]).set(Class.forName(attr[0]), obj);
        } catch (IllegalAccessException e) {
            e.printStackTrace();
        } catch (NoSuchFieldException e) {
            e.printStackTrace();
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        }


    }*/

    public static void main(String[] args){

        //TestObjectForXStream o = new TestObjectForXStream(10, "OuterObject");
        //ClassHavingStaticMember o = new ClassHavingStaticMember(1000);
        //XStreamStateCarver.saveState(o, 1, "1", o.getClass().getCanonicalName());
        //x.saveState(TestObjectForXStream.class, TestObjectForXStream.class.toString());
        //XStreamStateCarver.saveState(10);
        //Object o = XStreamStateCarver.loadState("/tmp/trace/saveint.xml");
        //System.out.println(o.getClass());

        // ClassHavingStaticMember o = (ClassHavingStaticMember)XStreamStateCarver.loadState("/tmp/state.0.0.int.xml");
        // System.out.println(o.s);

    }
}
