import org.apache.commons.io.FileUtils;
import org.json.simple.JSONArray;
import org.json.simple.JSONValue;
import org.json.simple.parser.ContainerFactory;
import org.json.simple.parser.JSONParser;
import org.json.simple.parser.ParseException;

import java.io.*;
import java.util.*;


public class BideWrapper {
    String folderName;
    String bideFolder;
    Object obj;
    JSONArray array;
    Iterator iterator;
    JSONParser parser;
    ContainerFactory containerFactory;
    HashMap<String, Integer > methodHashMap;
    BufferedWriter bufferedWriter;
    int seqCount;
    int maxSeq;
    float seqTotal;
    int noOfmthds;

    public BideWrapper() {
        //this.folderName = folderName;
        this.containerFactory = new ContainerFactory(){
            public List creatArrayContainer() {
                return new ArrayList();
            }

            public Map createObjectContainer() {
                return new LinkedHashMap();
            }

        };
        this.methodHashMap = new HashMap<String, Integer>();
        this.parser = new JSONParser();
        seqCount = 0;
        maxSeq = 0;
        seqTotal = 0;
        noOfmthds = 0;
//        result = new ArrayList<ArrayList<String>>();

    }
    public void generateOP(){

        createBIDEIPfromSeqMap();
        createBIDESpec();
        for(String threshold : Settings.bide_threshold_values){
            File file = new File(Settings.basePath + Settings.subjectAppName + "\\" + threshold);
            file.mkdir();
            runBIDE(threshold);
           // formatBIDEOP(threshold);
        }

    }

    private void createBIDEIPfromSeqMap() {
        try {
//            obj = JSONValue.parse(new FileReader(this.folderName+ "data\\nanoxml-method-map.json"));
            obj = JSONValue.parse(new FileReader(Settings.methodMapFile));
            array=(JSONArray)obj;
            noOfmthds = array.size();
            boolean flag = false;
            JSONArray seq = new JSONArray();
//            bufferedWriter = new BufferedWriter(new FileWriter(bideFolder + "BideIP.txt"));
            bufferedWriter = new BufferedWriter(new FileWriter(Settings.bideInputFileName));
            obj = JSONValue.parse(new FileReader(Settings.methodSequenceFile));
            array=(JSONArray)obj;
            iterator = array.iterator();
            while (iterator.hasNext()){
                String line = iterator.next().toString();
                Map lineMap = (Map)parser.parse(line, containerFactory);
//                System.out.println(lineMap.get("method-id"));
                String mthdString = lineMap.get("method-id").toString();
                int tempMthdCount = 0;
                for(String str : mthdString.substring(1,mthdString.length()-1).split(", ")){
//                    System.out.println(str);
                    bufferedWriter.write(str + " ");
                    tempMthdCount = tempMthdCount + 1;
                }
                bufferedWriter.write("-1");
                bufferedWriter.newLine();
                if(tempMthdCount > this.maxSeq){
                    this.maxSeq = tempMthdCount;
                }
                this.seqTotal = this.seqTotal + tempMthdCount;
                this.seqCount = this.seqCount + 1;


            }
            bufferedWriter.write("-2");
            bufferedWriter.close();
        } catch (IOException e) {
            e.printStackTrace();
        } catch (ParseException e) {
            e.printStackTrace();
        }
    }

    private void createBIDESpec() {
        try {
//            bufferedWriter = new BufferedWriter(new FileWriter(bideFolder + "BideIP.spec"));
            bufferedWriter = new BufferedWriter(new FileWriter(Settings.bideSpecFileName));
//            bufferedWriter.write(bideFolder + "BideIP.txt");
//            System.out.print(Settings.bideInputFileName);
//            System.out.println("haha");
            bufferedWriter.write(Settings.bideInputFileName.trim());
            bufferedWriter.newLine();
            bufferedWriter.write(String.valueOf(noOfmthds));
            bufferedWriter.newLine();
            bufferedWriter.write(String.valueOf(seqCount));
            bufferedWriter.newLine();
            bufferedWriter.write(String.valueOf(maxSeq));
            bufferedWriter.newLine();
            bufferedWriter.write(String.valueOf(Math.round(seqTotal / seqCount)));
            bufferedWriter.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }



    public static void main(String[] args) {
        BideWrapper test = new BideWrapper();
        test.generateOP();

    }


    private void runBIDE(String threshold) {
        String line;
        Process pr = null;
        try {

            FileUtils.forceMkdir(new File(Settings.batchFileNameBase + threshold));
            File f = new File(Settings.batchFileNameBase + threshold + Settings.batchFileNameEnd);
            f.createNewFile();
//            comment the following 3 lines if direct command from another file
            BufferedWriter bw = new BufferedWriter(new FileWriter(f));
            bw.write("cd " + Settings.basePath + Settings.subjectAppName + "\\" + threshold);
            bw.newLine();
            bw.write(Settings.bideExecFolder + "BIDEwithOUTPUT.exe " + Settings.bideSpecFileName + " " + threshold + " > output.log");
            bw.close();
//            change file name here for direct execution
            pr = Runtime.getRuntime().exec(Settings.batchFileNameBase + threshold + Settings.batchFileNameEnd);

            BufferedReader Resultset = new BufferedReader(
                    new InputStreamReader (
                            pr.getInputStream()));

            while((line=Resultset.readLine())!=null)
            {
                System.out.println(line);
            }

            String currentDir = System.getProperty("user.dir");
            FileUtils.copyFile(new File(currentDir + "\\frequent.dat"),
                    new File(Settings.batchFileNameBase + threshold + "\\frequent.dat"));

            FileUtils.copyFile(new File(currentDir + "\\output.log"),
                    new File(Settings.batchFileNameBase + threshold + "\\output.log"));

            FileUtils.forceDelete(new File(currentDir + "\\frequent.dat"));
            FileUtils.forceDelete(new File(currentDir + "\\output.log"));

            //FileUtils.opyFile(new File(Settings.bideExecFolder + "frequent.dat"),
        } catch (IOException e) {
            e.printStackTrace();
        }
    }




}
