package com.google.shtutxml.acceptancetests;


import com.google.shtutxml.DepthDocumentVisitor;
import com.google.shtutxml.DocumentPrinter;
import com.google.shtutxml.Example;
import com.google.shtutxml.StrXML;
import org.junit.Test;
import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.xml.sax.SAXException;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.util.logging.Level;
import java.util.logging.Logger;

public class AcceptanceTest {
    public static void printDoc(Node e) {
        new DocumentPrinter().visit(e, DepthDocumentVisitor.VisitOrder.DEPTH_FIRST);
    }

    public static Document parse(InputStream in) throws ParserConfigurationException, SAXException, IOException {
        DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
        DocumentBuilder db = dbf.newDocumentBuilder();

        return db.parse(in);
    }

    public void AcceptanceTesting1()
    {
        try {
            Document xmlDocument = parse(Example.class.getResourceAsStream("/AcceptanceTest1.xml"));
            StrXML demo = new StrXML(xmlDocument);

            System.out.println("************* BASE DOCUMENT *****************");
            printDoc(xmlDocument);

            System.out.println("\n*** Text ***");
            System.out.println("\"" + demo.getText() + "\"");

            System.out.println("\n*** Node of each text segment ***");
            System.out.println(demo.toString());

            System.out.println("\n*** Offset testing ***");
            System.out.println("offset " + 0 + " is at " + demo.getOffset(0));
            //System.out.println("offset " + 40 + " is at " + demo.getOffset(40));
            //System.out.println("offset " + 80 + " is at " + demo.getOffset(80));

            System.out.println();

            System.out.println("*********** Manipulation *****************");

            // demo.splitSectionUpTo(demo.GetOffset(2), demo.GetOffset(2).getParentNode().getParentNode());
            demo.insertAndSplitInserted(xmlDocument.createElement("Des1"), demo.getOffset(14), demo.getOffset(19));
            // demo.insertAndSplitInserted(xmlDocument.createElement("Des2"), demo.getOffset(20), demo.getOffset(28));



            //demo.insertAndSplitInserted(xmlDocument.createElement("k"), demo.getOffset(1), demo.getOffset(4));

            printDoc(xmlDocument);

            demo.insertAndSplitParent(xmlDocument.createElement("Unwanted"), demo.getOffset(19), demo.getOffset(20));

            try
            {
                TransformerFactory transformerFactory = TransformerFactory.newInstance();
                Transformer transformer = transformerFactory.newTransformer();
                DOMSource source = new DOMSource(xmlDocument);
                StreamResult streamResult =  new StreamResult(new File("D:\\AcceptanceTest1.xml"));
                transformer.transform(source, streamResult);
            }
            catch(Exception ex)
            {

            }

            printDoc(xmlDocument);
            System.out.println("\n*** Text ***");
            System.out.println("\"" + demo.getText() + "\"");

            System.out.println("\n*** Node of each text segment ***");
            System.out.println(demo.toString());


        } catch (ParserConfigurationException ex) {
            Logger.getLogger(Example.class.getName()).log(Level.SEVERE, null, ex);
        } catch (SAXException ex) {
            Logger.getLogger(Example.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IOException ex) {
            Logger.getLogger(Example.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    public void AcceptanceTesting2()
    {
        try {
            Document xmlDocument = parse(Example.class.getResourceAsStream("/AcceptanceTest2.xml"));
            StrXML demo = new StrXML(xmlDocument);

            System.out.println("************* BASE DOCUMENT *****************");
            printDoc(xmlDocument);

            System.out.println("\n*** Text ***");
            System.out.println("\"" + demo.getText() + "\"");

            System.out.println("\n*** Node of each text segment ***");
            System.out.println(demo.toString());

            System.out.println("\n*** Offset testing ***");
            System.out.println("offset " + 0 + " is at " + demo.getOffset(0));
            //System.out.println("offset " + 40 + " is at " + demo.getOffset(40));
            //System.out.println("offset " + 80 + " is at " + demo.getOffset(80));

            System.out.println();

            System.out.println("*********** Manipulation *****************");

            // demo.splitSectionUpTo(demo.GetOffset(2), demo.GetOffset(2).getParentNode().getParentNode());
            demo.insertAndSplitInserted(xmlDocument.createElement("Des1"), demo.getOffset(14), demo.getOffset(19));
            // demo.insertAndSplitInserted(xmlDocument.createElement("Des2"), demo.getOffset(20), demo.getOffset(28));



            //demo.insertAndSplitInserted(xmlDocument.createElement("k"), demo.getOffset(1), demo.getOffset(4));

            printDoc(xmlDocument);

            demo.insertAndSplitParent(xmlDocument.createElement("Unwanted"), demo.getOffset(19), demo.getOffset(20));

            try
            {
                TransformerFactory transformerFactory = TransformerFactory.newInstance();
                Transformer transformer = transformerFactory.newTransformer();
                DOMSource source = new DOMSource(xmlDocument);
                StreamResult streamResult =  new StreamResult(new File("D:\\AcceptanceTest1.xml"));
                transformer.transform(source, streamResult);
            }
            catch(Exception ex)
            {

            }

            printDoc(xmlDocument);
            System.out.println("\n*** Text ***");
            System.out.println("\"" + demo.getText() + "\"");

            System.out.println("\n*** Node of each text segment ***");
            System.out.println(demo.toString());


        } catch (ParserConfigurationException ex) {
            Logger.getLogger(Example.class.getName()).log(Level.SEVERE, null, ex);
        } catch (SAXException ex) {
            Logger.getLogger(Example.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IOException ex) {
            Logger.getLogger(Example.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
    public void AcceptanceTesting3()
    {
        try {
            Document xmlDocument = parse(Example.class.getResourceAsStream("/AcceptanceTest3.xml"));
            StrXML demo = new StrXML(xmlDocument);

            System.out.println("************* BASE DOCUMENT *****************");
            printDoc(xmlDocument);

            System.out.println("\n*** Text ***");
            System.out.println("\"" + demo.getText() + "\"");

            System.out.println("\n*** Node of each text segment ***");
            System.out.println(demo.toString());

            System.out.println("\n*** Offset testing ***");
            System.out.println("offset " + 0 + " is at " + demo.getOffset(0));
            //System.out.println("offset " + 40 + " is at " + demo.getOffset(40));
            //System.out.println("offset " + 80 + " is at " + demo.getOffset(80));

            System.out.println();

            System.out.println("*********** Manipulation *****************");

            // demo.splitSectionUpTo(demo.GetOffset(2), demo.GetOffset(2).getParentNode().getParentNode());
            demo.insertAndSplitInserted(xmlDocument.createElement("Des1"), demo.getOffset(14), demo.getOffset(19));
            // demo.insertAndSplitInserted(xmlDocument.createElement("Des2"), demo.getOffset(20), demo.getOffset(28));



            //demo.insertAndSplitInserted(xmlDocument.createElement("k"), demo.getOffset(1), demo.getOffset(4));

            printDoc(xmlDocument);

            demo.insertAndSplitParent(xmlDocument.createElement("Unwanted"), demo.getOffset(19), demo.getOffset(20));

            try
            {
                TransformerFactory transformerFactory = TransformerFactory.newInstance();
                Transformer transformer = transformerFactory.newTransformer();
                DOMSource source = new DOMSource(xmlDocument);
                StreamResult streamResult =  new StreamResult(new File("D:\\AcceptanceTest1.xml"));
                transformer.transform(source, streamResult);
            }
            catch(Exception ex)
            {

            }

            printDoc(xmlDocument);
            System.out.println("\n*** Text ***");
            System.out.println("\"" + demo.getText() + "\"");

            System.out.println("\n*** Node of each text segment ***");
            System.out.println(demo.toString());


        } catch (ParserConfigurationException ex) {
            Logger.getLogger(Example.class.getName()).log(Level.SEVERE, null, ex);
        } catch (SAXException ex) {
            Logger.getLogger(Example.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IOException ex) {
            Logger.getLogger(Example.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
    public void AcceptanceTesting4()
    {
        try {
            Document xmlDocument = parse(Example.class.getResourceAsStream("/AcceptanceTest4.xml"));
            StrXML demo = new StrXML(xmlDocument);

            System.out.println("************* BASE DOCUMENT *****************");
            printDoc(xmlDocument);

            System.out.println("\n*** Text ***");
            System.out.println("\"" + demo.getText() + "\"");

            System.out.println("\n*** Node of each text segment ***");
            System.out.println(demo.toString());

            System.out.println("\n*** Offset testing ***");
            System.out.println("offset " + 0 + " is at " + demo.getOffset(0));
            //System.out.println("offset " + 40 + " is at " + demo.getOffset(40));
            //System.out.println("offset " + 80 + " is at " + demo.getOffset(80));

            System.out.println();

            System.out.println("*********** Manipulation *****************");

            // demo.splitSectionUpTo(demo.GetOffset(2), demo.GetOffset(2).getParentNode().getParentNode());
            demo.insertAndSplitInserted(xmlDocument.createElement("Des1"), demo.getOffset(14), demo.getOffset(19));
            // demo.insertAndSplitInserted(xmlDocument.createElement("Des2"), demo.getOffset(20), demo.getOffset(28));



            //demo.insertAndSplitInserted(xmlDocument.createElement("k"), demo.getOffset(1), demo.getOffset(4));

            printDoc(xmlDocument);

            demo.insertAndSplitParent(xmlDocument.createElement("Unwanted"), demo.getOffset(19), demo.getOffset(20));

            try
            {
                TransformerFactory transformerFactory = TransformerFactory.newInstance();
                Transformer transformer = transformerFactory.newTransformer();
                DOMSource source = new DOMSource(xmlDocument);
                StreamResult streamResult =  new StreamResult(new File("D:\\AcceptanceTest1.xml"));
                transformer.transform(source, streamResult);
            }
            catch(Exception ex)
            {

            }

            printDoc(xmlDocument);
            System.out.println("\n*** Text ***");
            System.out.println("\"" + demo.getText() + "\"");

            System.out.println("\n*** Node of each text segment ***");
            System.out.println(demo.toString());


        } catch (ParserConfigurationException ex) {
            Logger.getLogger(Example.class.getName()).log(Level.SEVERE, null, ex);
        } catch (SAXException ex) {
            Logger.getLogger(Example.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IOException ex) {
            Logger.getLogger(Example.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
    public void AcceptanceTesting5()
    {
        try {
            Document xmlDocument = parse(Example.class.getResourceAsStream("/AcceptanceTest5.xml"));
            StrXML demo = new StrXML(xmlDocument);

            System.out.println("************* BASE DOCUMENT *****************");
            printDoc(xmlDocument);

            System.out.println("\n*** Text ***");
            System.out.println("\"" + demo.getText() + "\"");

            System.out.println("\n*** Node of each text segment ***");
            System.out.println(demo.toString());

            System.out.println("\n*** Offset testing ***");
            System.out.println("offset " + 0 + " is at " + demo.getOffset(0));
            //System.out.println("offset " + 40 + " is at " + demo.getOffset(40));
            //System.out.println("offset " + 80 + " is at " + demo.getOffset(80));

            System.out.println();

            System.out.println("*********** Manipulation *****************");

            // demo.splitSectionUpTo(demo.GetOffset(2), demo.GetOffset(2).getParentNode().getParentNode());
            demo.insertAndSplitInserted(xmlDocument.createElement("Des1"), demo.getOffset(14), demo.getOffset(19));
            // demo.insertAndSplitInserted(xmlDocument.createElement("Des2"), demo.getOffset(20), demo.getOffset(28));



            //demo.insertAndSplitInserted(xmlDocument.createElement("k"), demo.getOffset(1), demo.getOffset(4));

            printDoc(xmlDocument);

            demo.insertAndSplitParent(xmlDocument.createElement("Unwanted"), demo.getOffset(19), demo.getOffset(20));

            try
            {
                TransformerFactory transformerFactory = TransformerFactory.newInstance();
                Transformer transformer = transformerFactory.newTransformer();
                DOMSource source = new DOMSource(xmlDocument);
                StreamResult streamResult =  new StreamResult(new File("D:\\AcceptanceTest1.xml"));
                transformer.transform(source, streamResult);
            }
            catch(Exception ex)
            {

            }

            printDoc(xmlDocument);
            System.out.println("\n*** Text ***");
            System.out.println("\"" + demo.getText() + "\"");

            System.out.println("\n*** Node of each text segment ***");
            System.out.println(demo.toString());


        } catch (ParserConfigurationException ex) {
            Logger.getLogger(Example.class.getName()).log(Level.SEVERE, null, ex);
        } catch (SAXException ex) {
            Logger.getLogger(Example.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IOException ex) {
            Logger.getLogger(Example.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    @Test
    public void runAcceptance()
    {
        new AcceptanceTest().AcceptanceTesting1();
        new AcceptanceTest().AcceptanceTesting2();
        new AcceptanceTest().AcceptanceTesting3();
        new AcceptanceTest().AcceptanceTesting4();
        new AcceptanceTest().AcceptanceTesting5();


    }




}
