package net.n3.nanoxml;

import java.lang.reflect.Field;
import java.lang.reflect.Method;

public class NanoXMLUtil {

    static Object getField(Object instance, String fieldName) throws Exception
    {
        Class c = instance.getClass();

        // Retrieve the field with the specified name
        Field f = c.getDeclaredField( fieldName );
        f.setAccessible( true );

        // Return the value of the field for the instance
        return f.get( instance );
    }

    public static Object executeMethod( Object instance, String name, Object[] params ) throws Exception
    {
        Class c 	= instance.getClass();

        // Fetch the Class types of all method parameters
        Class[] types 	= new Class[params.length];

        for ( int i = 0; i < params.length; i++ )
            types[i] = params[i].getClass();
        Method m        = c.getDeclaredMethod( name, types );
        m.setAccessible( true );
        return m.invoke( instance, params );
    }

}
