package net.n3.nanoxml;

import junit.framework.TestCase;

import java.util.Hashtable;
import java.util.Properties;
import java.util.Stack;


public class NonValidatorTest extends TestCase {
	//private NonValidator target=null;
	//private IXMLEntityResolver resolver=null;
	//private String systemID;
    /*
	public void setUp()
	{
		target=new NonValidator();
		resolver=new XMLEntityResolver();
		target.setParameterEntityResolver(resolver);
		
	} */


    /**
	 * This utility function skips the number of characters while reading
	 * from an input file
	 * 
	 * @param reader
	 * @param numberOfChars
	 * @throws Exception
	 */
	//skips the < , !, third Character (E or A) from the DTD 
	private void skipCharacters(IXMLReader reader,int numberOfChars) throws Exception
	{
		int i=0;
		while(i<numberOfChars)
		{
			String str = XMLUtil.read(reader, '%');
			char ch = str.charAt(0);
			i++;
		}
	}
	
	//checks whether the Entity in DTD is added to the hashTable.
	public void testProcessEntity() throws Exception
	{

        NonValidator target = new NonValidator();
        IXMLEntityResolver resolver = new XMLEntityResolver();
        target.setParameterEntityResolver(resolver);

		IXMLReader reader=StdXMLReader.fileReader("src/test/resources/example.dtd");
		skipCharacters(reader,3);
		Hashtable entities=(Hashtable) NanoXMLUtil.getField(resolver, "entities");
		assertNull(entities.get("p"));
		target.processEntity(reader,resolver );
		assertEquals("(#PCDATA)",entities.get("p"));
	}
	
	public void testProcessEntitySystemID() throws Exception
	{

        NonValidator target = new NonValidator();
        IXMLEntityResolver resolver = new XMLEntityResolver();
        target.setParameterEntityResolver(resolver);

		IXMLReader reader=StdXMLReader.fileReader("src/test/resources/ProcessSysIDEntity.dtd");
		skipCharacters(reader,3);
		Hashtable entities=(Hashtable) NanoXMLUtil.getField(resolver, "entities");
		target.processEntity(reader,resolver );
		String[] str=(String[])entities.get("student");
		assertNull((str[0]));
		assertEquals("example.dtd",(str[1]));
	}
	
	public void testProcessEntityPublicID() throws Exception
	{

        NonValidator target = new NonValidator();
        IXMLEntityResolver resolver = new XMLEntityResolver();
        target.setParameterEntityResolver(resolver);

		IXMLReader reader=StdXMLReader.fileReader("src/test/resources/ProcessPubIDEntity.dtd");
		skipCharacters(reader,3);
		Hashtable entities=(Hashtable) NanoXMLUtil.getField(resolver, "entities");
		target.processEntity(reader,resolver );
		String[] str=(String[])entities.get("student");
		assertEquals("pubID",(str[0]));
		assertEquals("example.dtd",(str[1]));
	}
	
	public void testProcessAttListElement() throws Exception
	{

        NonValidator target = new NonValidator();
        IXMLEntityResolver resolver = new XMLEntityResolver();
        target.setParameterEntityResolver(resolver);

		IXMLReader reader=StdXMLReader.fileReader("src/test/resources/ProcessAttList.dtd");
		skipCharacters(reader,3);
		target.processAttList(reader,resolver );
		Hashtable attributeValues=(Hashtable) NanoXMLUtil.getField(target, "attributeDefaultValues");
		Properties prop=(Properties)attributeValues.get("payment");
		assertTrue(prop.containsKey("type"));
		assertEquals("check",prop.get("type"));
		
	}

	public void testProcessAttListDefaultValElement() throws Exception
	{

        NonValidator target = new NonValidator();
        IXMLEntityResolver resolver = new XMLEntityResolver();
        target.setParameterEntityResolver(resolver);

		IXMLReader reader=StdXMLReader.fileReader("src/test/resources/ProcessAttListDefaultVal.dtd");
		skipCharacters(reader,3);
		target.processAttList(reader,resolver );
		Hashtable attributeValues=(Hashtable) NanoXMLUtil.getField(target, "attributeDefaultValues");
		Properties prop=(Properties)attributeValues.get("person");
		assertTrue(prop.containsKey("number"));
		assertEquals("12",prop.get("number"));
	}
	
	
	public void testProcessElementWithEntity() throws Exception
	{


        NonValidator target = new NonValidator();
        IXMLEntityResolver resolver = new XMLEntityResolver();
        target.setParameterEntityResolver(resolver);

		IXMLReader reader=StdXMLReader.fileReader("src/test/resources/example.dtd");
		skipCharacters(reader,1);
		Hashtable entities=(Hashtable) NanoXMLUtil.getField(resolver, "entities");
		assertNull(entities.get("p"));
		target.processElement(reader, resolver);
		assertEquals("(#PCDATA)",entities.get("p"));
	}
	
	public void testProcessElementWithAttribute() throws Exception
	{

        NonValidator target = new NonValidator();
        IXMLEntityResolver resolver = new XMLEntityResolver();
        target.setParameterEntityResolver(resolver);

		IXMLReader reader=StdXMLReader.fileReader("src/test/resources/ProcessAttList.dtd");
		skipCharacters(reader,1);
		target.processElement(reader, resolver);
		Hashtable attributeValues=(Hashtable) NanoXMLUtil.getField(target, "attributeDefaultValues");
		Properties prop=(Properties)attributeValues.get("payment");
		assertTrue(prop.containsKey("type"));
		assertEquals("check",prop.get("type"));
		
	}
	
	public void testParseDTDEntity() throws Exception
	{

        NonValidator target = new NonValidator();
        IXMLEntityResolver resolver = new XMLEntityResolver();
        target.setParameterEntityResolver(resolver);

		IXMLReader reader=StdXMLReader.fileReader("src/test/resources/example.dtd");
		target.parseDTD(null,reader, resolver,true);
		Hashtable entities=(Hashtable) NanoXMLUtil.getField(resolver, "entities");
		assertEquals("(#PCDATA)",entities.get("p"));
	}
	
	public void testParseDTDEntityPublSysID() throws Exception
    {

        NonValidator target = new NonValidator();
        IXMLEntityResolver resolver = new XMLEntityResolver();
        target.setParameterEntityResolver(resolver);

		String systemID="src/test/resources/ProcessPubIDEntity.dtd";
		IXMLReader reader=StdXMLReader.fileReader(systemID);
		Hashtable entities=(Hashtable) NanoXMLUtil.getField(resolver, "entities");
		target.parseDTD(null,reader, resolver,true);
		String[] str=(String[])entities.get("student");
		assertEquals("pubID",(str[0]));
		assertEquals("example.dtd",(str[1]));
	}
	
	public void testParseDTDAtListElement() throws Exception
    {

        NonValidator target = new NonValidator();
        IXMLEntityResolver resolver = new XMLEntityResolver();
        target.setParameterEntityResolver(resolver);

		String systemID="src/test/resources/ProcessAttList.dtd";
		IXMLReader reader=StdXMLReader.fileReader(systemID);
		target.parseDTD(null,reader, resolver,true);
		Hashtable attributeValues=(Hashtable) NanoXMLUtil.getField(target, "attributeDefaultValues");
		Properties prop=(Properties)attributeValues.get("payment");
		assertTrue(prop.containsKey("type"));
		assertEquals("check",prop.get("type"));
		
	}

    /*
	public void testParseDTDAttListDefaultValElement() throws Exception
	{
		systemID="src/test/resources/ProcessAttListDefaultVal.dtd";
		IXMLReader reader=StdXMLReader.fileReader(systemID);
		target.parseDTD(null,reader, resolver,true);
		Hashtable attributeValues=(Hashtable)getField(target,"attributeDefaultValues");
		Properties prop=(Properties)attributeValues.get("person");
		assertTrue(prop.containsKey("number"));
		assertEquals("12",prop.get("number"));
	} */
	
	
	//checks whether the element is started while processing the DTD
	public void testElementStarted() throws Exception
    {

        NonValidator target = new NonValidator();
        IXMLEntityResolver resolver = new XMLEntityResolver();
        target.setParameterEntityResolver(resolver);

		String systemID="src/test/resources/ProcessAttList.dtd";
		IXMLReader reader=StdXMLReader.fileReader(systemID);
		target.parseDTD(null,reader, resolver,true);
		Hashtable attributeValues=(Hashtable) NanoXMLUtil.getField(target, "attributeDefaultValues");
		Properties prop=(Properties)attributeValues.get("payment");
		target.elementStarted("payment",systemID,1);
		Stack currElements=(Stack) NanoXMLUtil.getField(target, "currentElements");
		Properties top=(Properties)currElements.peek();
		assertEquals(prop.get("type"),top.get("type"));
		
	}
	
	public void testElementStartedAttributesNull() throws Exception
    {

        NonValidator target = new NonValidator();
        //IXMLEntityResolver resolver = new XMLEntityResolver();
        //target.setParameterEntityResolver(resolver);

		String systemID="src/test/resources/ProcessAttList.dtd";
		IXMLReader reader=StdXMLReader.fileReader(systemID);
		IXMLEntityResolver resolver=new XMLEntityResolver();
		target.setParameterEntityResolver(resolver);
		target.elementStarted("payment",systemID,1);
		Stack currElements=(Stack) NanoXMLUtil.getField(target, "currentElements");
		Properties top=(Properties)currElements.peek();
		assertNull(top.get("type"));
		
	}
	
	//checks whether the attributes and its values are processed
	public void testElementAttributeProcess() throws Exception
    {

        NonValidator target = new NonValidator();
        IXMLEntityResolver resolver = new XMLEntityResolver();
        target.setParameterEntityResolver(resolver);

		String systemID="src/test/resources/ProcessAttList.dtd";
		IXMLReader reader=StdXMLReader.fileReader(systemID);
		target.parseDTD(null,reader, resolver,true);
		target.elementStarted("payment",systemID,1);
		Stack currElements=(Stack) NanoXMLUtil.getField(target, "currentElements");
		Properties top=(Properties)currElements.peek();
		Properties extraAttributes=new Properties();
		target.elementAttributesProcessed("payment",extraAttributes, systemID, 1);
		assertEquals(extraAttributes.get("type"),top.get("type"));
	
	}
}
