package net.n3.nanoxml;

import junit.framework.TestCase;

import static net.n3.nanoxml.NanoXMLUtil.executeMethod;

public class XMLAttributeTest extends TestCase {
	
	/**
	 * Executes a method on an object instance.  The name and parameters of
	 * the method are specified.  The method will be executed and the value
	 * of it returned, even if the method would have private or protected access.
	 */

	
	public void testFullName() throws Exception
	{
        XMLAttribute target=new XMLAttribute("type","type","nameSpace","123","int");
		String fullName= (String) executeMethod(target, "getFullName", new String[]{});
		assertEquals("type",fullName);
	}
	
	
	public void testName() throws Exception
	{
        XMLAttribute target=new XMLAttribute("type","type","nameSpace","123","int");
		String name= (String) executeMethod(target, "getName", new String[] { } );
		assertEquals("type",name);
	}
	
	
	public void testNameSpace() throws Exception
	{
        XMLAttribute target=new XMLAttribute("type","type","nameSpace","123","int");
		String nameSpace= (String) executeMethod(target, "getNamespace", new String[] { } );
		assertEquals("nameSpace",nameSpace);
	}
	
	
	public void testValue() throws Exception
	{
        XMLAttribute target=new XMLAttribute("type","type","nameSpace","123","int");
		String value= (String) executeMethod(target, "getValue", new String[] { } );
		assertEquals("123",value);
	}
	
	
	public void testGetType() throws Exception
	{
        XMLAttribute target=new XMLAttribute("type","type","nameSpace","123","int");
		String type= (String) executeMethod(target, "getType", new String[] { } );
		assertEquals("int",type);
	}
}
