package net.n3.nanoxml;

import junit.framework.TestCase;

import java.io.FileNotFoundException;


public class XMLExceptionTest extends TestCase {

	//private XMLException target=null;
	public void setUp()
	{

	}
		
	public void testXMLExceptionWithMessage() throws Exception
	{
        XMLException target=new XMLException("Exception message");
		target=new XMLException("Exception message");
		String message=(String)NanoXMLUtil.getField(target,"msg");
		String sysID=(String)NanoXMLUtil.getField(target,"systemID");
		Exception ex=(Exception)NanoXMLUtil.getField(target,"encapsulatedException");
		assertEquals("Exception message",message);
		assertNull(sysID);
	    assertNull(ex);
	 }
	
	
	public void testIllegalAccessException() throws Exception
	{
        XMLException target=new XMLException("Exception message");
		IllegalArgumentException e=new IllegalArgumentException();
		target=new XMLException(e);
		String message=(String)NanoXMLUtil.getField(target,"msg");
		String sysID=(String)NanoXMLUtil.getField(target,"systemID");
		Exception ex=(Exception)NanoXMLUtil.getField(target,"encapsulatedException");
		assertEquals("Nested Exception",message);
		assertEquals("java.lang.IllegalArgumentException",e.toString());
		
	 }
	
	public void testClassNotFound() throws Exception
	{   XMLException target=new XMLException("Exception message");
		ClassNotFoundException e=new ClassNotFoundException();
		target=new XMLException(e);
		String message=(String)NanoXMLUtil.getField(target,"msg");
		String sysID=(String)NanoXMLUtil.getField(target,"systemID");
		Exception ex=(Exception)NanoXMLUtil.getField(target,"encapsulatedException");
		assertEquals("Nested Exception",message);
		assertEquals("java.lang.ClassNotFoundException",e.toString());
	}
	
	
	public void testFileNotFoundException() throws Exception
	{   XMLException target=new XMLException("Exception message");
		FileNotFoundException e=new FileNotFoundException();
		target=new XMLException(e);
		assertEquals("Nested Exception",target.toString());
		assertEquals("java.io.FileNotFoundException",e.toString());
		
	 }
	
	
	public void testXMLIllegalArgumentException() throws Exception
	{   XMLException target=new XMLException("Exception message");
		Exception e=new IllegalArgumentException();
		target=new XMLException("main.dtd",8,e,"child cannot be null",true);
		assertEquals("child cannot be null, SystemID='main.dtd', Line=8, Exception: java.lang.IllegalArgumentException",target.toString());
		assertEquals("java.lang.IllegalArgumentException",target.getException().toString());
	}
}
